
<shader>
	<gles version="2">
		<vsh>
			<src>

vec4 xform_vec_by_mat34(vec4 tm[3], vec4 v)
{
	vec4 o;
	o.x = dot(tm[0], v);
	o.y = dot(tm[1], v);
	o.z = dot(tm[2], v);
	o.w = v.w;
	return o;
}
vec4 xform_vec_by_mat44(vec4 tm[4], vec4 v)
{
	vec4 o;
	o.x = dot(tm[0], v);
	o.y = dot(tm[1], v);
	o.z = dot(tm[2], v);
	o.w = dot(tm[3], v);
	return o;
}
vec4 xform_pos(vec4 viewProjTransform[4], vec4 worldTransform[3], vec3 vPos)
{
	return xform_vec_by_mat44(viewProjTransform, xform_vec_by_mat34(worldTransform, vec4(vPos,1)));
}



// globals
uniform vec4 worldTransform[3];
uniform vec4 viewProjTransform[4];
uniform vec2 texCoordScale;

// input
attribute vec3 vPosition;
attribute vec2 vTexCoord;

// output
varying lowp vec2 fTexCoord;

void main()
{
	gl_Position = xform_pos(viewProjTransform, worldTransform, vPosition);
	fTexCoord = texCoordScale * vTexCoord;
}



			</src>
		</vsh>



		<fsh>
			<src>


precision highp float;

// globals
uniform sampler2D fontTexture;
uniform lowp vec4 textColor;

// input
varying lowp vec2 fTexCoord;

void main()
{
#ifdef TACO_PLATFORM_IOS
	vec4 s = texture2D(fontTexture, fTexCoord);
	s.rgb /= max(0.004, s.a);
	gl_FragColor = s * textColor;
#else
	vec4 s = texture2D(fontTexture, fTexCoord);
	gl_FragColor = s * textColor;
	#ifdef PREMULTIPLY_BY_ALPHA
		gl_FragColor.rgb *= gl_FragColor.a;
	#endif
#endif
}



			</src>
		</fsh>
	</gles>
</shader>