
<shader>
	<gles version="2">
		<vsh>
			<src>
			
vec4 xform_vec_by_mat34(vec4 tm[3], vec4 v)
{
	vec4 o;
	o.x = dot(tm[0], v);
	o.y = dot(tm[1], v);
	o.z = dot(tm[2], v);
	o.w = v.w;
	return o;
}
vec4 xform_vec_by_mat44(vec4 tm[4], vec4 v)
{
	vec4 o;
	o.x = dot(tm[0], v);
	o.y = dot(tm[1], v);
	o.z = dot(tm[2], v);
	o.w = dot(tm[3], v);
	return o;
}
vec4 xform_pos(vec4 viewProjTransform[4], vec4 worldTransform[3], vec3 vPos)
{
	return xform_vec_by_mat44(viewProjTransform, xform_vec_by_mat34(worldTransform, vec4(vPos,1)));
}



// globals
uniform vec4 worldTransform[3];
uniform vec4 viewProjTransform[4];
uniform vec4 texCoordTransform0;

// input
attribute vec3 vPosition;
attribute vec2 vTexCoord;

// output
varying vec2 fTexCoord;

void main()
{
	gl_Position = xform_pos(viewProjTransform, worldTransform, vPosition);
	fTexCoord = texCoordTransform0.xy * vTexCoord + texCoordTransform0.zw;
}



			</src>
		</vsh>



		<fsh>
			<src>


precision highp float;

// globals
uniform sampler2D fullBrightTexture;
uniform lowp vec4 colorTint;

// input
varying vec2 fTexCoord;

#ifdef FLIP_V
	#define UV(uv) vec2(uv.x, 1.0 - uv.y)
#else
	#define UV(uv) uv
#endif

void main()
{
	gl_FragColor = colorTint * texture2D(fullBrightTexture, UV(fTexCoord));
}



			</src>
		</fsh>
	</gles>
</shader>