
<shader>
	<gles version="2">
		<vsh>
			<src>

vec4 xform_vec_by_mat34(vec4 tm[3], vec4 v)
{
	vec4 o;
	o.x = dot(tm[0], v);
	o.y = dot(tm[1], v);
	o.z = dot(tm[2], v);
	o.w = v.w;
	return o;
}
vec4 xform_vec_by_mat44(vec4 tm[4], vec4 v)
{
	vec4 o;
	o.x = dot(tm[0], v);
	o.y = dot(tm[1], v);
	o.z = dot(tm[2], v);
	o.w = dot(tm[3], v);
	return o;
}
vec4 xform_pos(vec4 viewProjTransform[4], vec4 worldTransform[3], vec3 vPos)
{
	return xform_vec_by_mat44(viewProjTransform, xform_vec_by_mat34(worldTransform, vec4(vPos,1)));
}



// globals
uniform vec4 worldTransform[3];
uniform vec4 viewProjTransform[4];
uniform vec4 solidColor;
uniform vec4 colorTint;

// input
attribute vec3 vPosition;

// output
varying lowp vec4 fColor;

void main()
{
	gl_Position = xform_pos(viewProjTransform, worldTransform, vPosition);
	fColor = solidColor * colorTint;
}



			</src>
		</vsh>



		<fsh>
			<src>


precision highp float;

// input
varying lowp vec4 fColor;

void main()
{
	gl_FragColor = fColor;
	
#ifdef PREMULTIPLY_BY_ALPHA
	gl_FragColor.rgb *= gl_FragColor.a;
#endif
}



			</src>
		</fsh>
	</gles>
</shader>